/*
 * mp3plot - Bitrate analysis tool
 *
 * Copyright (C) 2007 Toni Corvera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

// $Id: mp3_file.h 717 2007-05-18 00:41:46Z  $

#ifndef ONET_MP3_H
#define ONET_MP3_H

#include <vector>
#include <fstream>
#include <string>
#include <memory>

#include <sysexits.h>
#include <ctype.h>

#include "mp3_common.h"
#include "mp3_tags.h"
#include "mp3_frame.h"

namespace net_outlyer {

namespace mp3 {

    class mp3file {
    protected:
        static void seek_to_next_frame(std::ifstream & input) throw (e_read_failure);
        mp3_filetypes_t file_type;
        id3v2header id3v2;
        std::vector<mp3frame>   frames;
        id3v1header id3v1;
        mp3_meta_info meta_info;
    public:

        mp3file()
            : file_type(UNKNOWN), meta_info()
        {}

        void check_file_type(std::ifstream & input) throw (e_error);
        void read_info(std::ifstream & input) throw (e_error);
        void dump_meta_info() const;
        void plot() const;
    };

} // namespace mp3

} // namespace net_outlyer

#endif // ONET_MP3_H

/* vim:set ts=4 et ai: */

